(function ($) {

    var performanceTimer = new Array();
    performanceTimer["JS_start"] = new Date().getTime();

    window.Site = {
        challengeElement: null,
        context: null,
        nav: 'header#masthead',
        mainNav: '#nav-main',
        footerH: 0,
        resetResponsiveStyle: false,
        enablePreloader: false,
        fullNavigationActive: false,
        navigationBreakpoint: 760,
        w: $(window),
        windowScrollTop: 0,
        windowWidth: 0,
        windowHeight: 0,
        bodyEl: 0,
        theme_directory: "",

        init: function () {
            this.theme_directory = FEIdirectory;

            //TODO: Replace .content-wrapper with custom element or value as there are many elements using this class.
            Site.contentWidth = $('.content-wrapper').width();

            /**
             * Requires jquery.placeholder.min.js
             * Add support for placeholder attribute in older browsers.
             */
            $('input[placeholder]').placeholder();

            /**
             * Set the initial breakpoint context
             */
            this.challengeElement = document.querySelector('.breakpoint-context');
            this.challengeContext();
            
            /* store important variables */
            this.windowWidth = this.w.width();
            this.windowHeight = this.w.height();
            this.windowScrollTop = this.w.scrollTop();
            this.bodyEl = $("body");

            /**
             * Check breakpoint context on window resizing
             * Throttled/debounced for better performance
             */

            $(window).on('resize', function () {
                Site.windowWidth = Site.w.width();
                Site.windowHeight = Site.w.height();
                Site.windowScrollTop = Site.w.scrollTop();
                Site.updateElements();
                timeout = setTimeout('Site.updateElements()', 300);
            });

            $(window).scroll(function () {
                Site.windowScrollTop = Site.w.scrollTop();
            });

            Site.updateElements = function () {
                Site.challengeContext();
                Site.setNavigation();
                //TODO: Replace .content-wrapper with custom element or value as there are many elements using this class.
                Site.contentWidth = $(".content-wrapper").width();


                if (Site.page == "home") Site.updateHome();
                else if (Site.page == "qualifier") Site.updateQualifiersSingle();
                else if (Site.page == "team") Site.updateTeamSingle();
                else if (Site.page == "stream-single") Site.updateSingleStream();
                else if (Site.page == 'final') Site.updateFinal();

                Site.fixFooterPos();
                //footer content
                $('#main').children('div').css("margin-top", $('#masthead').height());
                //TODO: update open footer content height (Site.footerH)
                if ($('#footer-content').height() != 0) {
                    $('#footer-content').css("height", "auto");

                    Site.footerH = $('#footer-content').height();
                } else {
                    $('#footer-content').css("height", "auto");
                    Site.footerH = $('#footer-content').height();
                    $('#footer-content').css("height", "0px");
                }

                if (Site.footerH > 0) {
                    $("#footer-content").addClass("active");
                }
                else {
                    $("#footer-content").removeClass("active");
                }

                if( Site.Skrollr !== false) {
                    Site.Skrollr.refresh();
                }
            };

            $('#masthead').on('click', '#toggle-menu', function () {
                Site.toggleMenu(this);
            });

            $("#nav-main.active a").click(function () {
                Site.hideMobileNav();
            });

            //document.addEventListener("touchmove", Site.hideMobileNav, false);
            //document.addEventListener("scroll", Site.hideMobileNav, false);


            /* diamond hover icon change and reset */

            $(".hover-icon").on('mouseover', function () {
                var $t = $(this);
                var hcn = $t.attr("data-icon-hover");
                var hco = $t.attr("data-icon-original")
                if (typeof hcn !== typeof undefined && hcn !== false) {
                    $t.find(".icon").removeClass(hco).addClass(hcn);
                }
            });

            $(".hover-icon").on('mouseout', function () {
                var $t = $(this);
                var hcn = $t.attr("data-icon-hover");
                var hco = $t.attr("data-icon-original")
                if (typeof hcn !== typeof undefined && hcn !== false) {
                    $t.find(".icon").removeClass(hcn).addClass(hco);
                }
            });

            /* toggle slideout */
            $(".toggle-flyout").click(function () {
                $t = $(this);
                $f = $(this).prev();

                if (!$f.hasClass("slided")) {
                    $(".toggle-flyout.active").removeClass("active");
                    $(".flyout-menu.slided").removeClass("slided");
                    $t.addClass("active");
                    $f.addClass("slided");
                }
                else {
                    $t.removeClass("active");
                    $f.removeClass("slided");
                }

                var FooterWidthInterval = window.setInterval(function () {
                    Site.fixFooterPos();
                }, 16);

                setTimeout(function () {
                    clearInterval(FooterWidthInterval);
                }, 400);
            });

            /* images loaded */

            $('.preload-image img').on('load', function () {
                $(this).addClass("loaded");
            });

            /* stream hover */
            $(".stream-gallery .stream-item").on("mouseover", function () {
                if (!$(this).find(".stream-sharing").hasClass("fadeIn")) {
                    $(this).find(".stream-sharing").addClass("fadeIn");
                }
            });
            $(".stream-gallery .stream-item").on("mouseleave", function () {
                $(this).find(".stream-sharing").removeClass("fadeIn");
            });

            /* create skrollr variable */
            Site.Skrollr = false;
        },

        resetQualifiersInlineStyles: function () {
            $('.qualifiers-month').each(function (index1, month) {
                //speed up
                $(month).find('li').each(function (index, eventItem) {
                    img = $(eventItem).find('img');
                    titleBox = $(eventItem).find('.title-box');

                    $(eventItem).removeAttr('style');
                    $(img).attr('style', '');
                    $(titleBox).attr('style', '');
                    $(titleBox).find(".title-box-inner").attr('style', '');

                });

                $(month).attr('style', '')
            });
        },

        initFEI: function () {
            /*------------------------  custom FEI JS  ------------------------------------------  */
            /*
             * */

            //load grunt icons
            grunticon([grunticonCSSdir + "/icons.data.svg.css", grunticonCSSdir + "/icons.data.png.css", grunticonCSSdir + "/icons.fallback.css"]);

            // determine page type
            if ($('body').hasClass('page-template-home')) {
                Site.page = "home";
            } else if ($('body').hasClass('single-event')) {
                Site.page = "qualifier";
            } else if ($('body').hasClass('single-team')) {
                Site.page = "team";
            } else if ($('body').hasClass("page-template-photostream") || $('body').hasClass("page-template-videostream") ) {
                Site.page = "stream-single";
            } else if ($('body').hasClass('page-template-about')) {
                Site.page = "about";
            } else if($('body').hasClass('page-template-final')) {
                Site.page = 'final';
            }

            //set top margin of all divs in #main to height of navigation
            $('#main').children('div').css("margin-top", $('#masthead').height());

            //scroll to anchorpoints ani
            $('a[href^="#"]').bind('click.smoothscroll', function (e) {

                event.preventDefault ? event.preventDefault() : event.returnValue = false;

                if (Site.hashInterval) clearInterval(Site.hashInterval);

                var target = this.hash;
                var $target;
                var sectionID = target.split("#").join('');
                if ($(target).hasClass("section-scroll")) {
                    $target = $(".section-scroll-" + sectionID);
                } else {
                    $target = $(target).find(".section-content");
                }

                if ($target.offset() == undefined)   return;

                var targScroll = $target.offset().top - 40 - parseInt($('#primary').css("margin-top"), 10);
                $('html, body').stop().animate({
                    // scroll to hash position, consider sticky menu height
                    'scrollTop': targScroll
                }, 900, 'swing', function () {
                    Site.setLocationAnchor(target);
                });
            });

            Site.setLocationAnchor = function (hash, jumpToSection) {
                var elementId = hash.split("#").join('');
                var el = document.getElementById(elementId);
                var id = el.id;
                if (!jumpToSection) el.removeAttribute('id');
                window.location.hash = hash;
                el.setAttribute('id', id);
            };

            $('.footer-left .top-link').bind('click.smoothscroll', function (e) {
                e.preventDefault();


                $('html, body').stop().animate({
                    // scroll to hash position, consider sticky menu height
                    'scrollTop': 0
                }, 900, 'swing');
            });

            //get footer content height
            $('#footer-content').css("height", "auto");
            Site.footerH = $('#footer-content').height();
            $('#footer-content').css("height", 0);

            Site.fixHomeAnchorPosition = function () {
                if (window.location.hash) {
                    // Fragment exists
                    var i = 0;
                    Site.hashInterval = window.setInterval(function () {
                        var target = window.location.hash;
                        var $target;
                        var sectionID = target.split("#").join('');
                        if ($(target).hasClass("section-scroll")) {
                            $target = $(".section-scroll-" + sectionID);
                        } else {
                            $target = $(target).find(".section-content");
                        }

                        if ($target.offset() == undefined)   return;

                        var targScroll = $target.offset().top - 40 - parseInt($('#primary').css("margin-top"), 10);

                        $(window).scrollTop(targScroll);
                        i++;
                        if (i == 5) {
                            clearInterval(Site.hashInterval);
                        }
                    }, 100);
                }
            };

            Site.curFooterDataLink = '';
            Site.toggleFooterContent = function (dataLink) {
                //if( $('#footer-content').height() != 0 &&  )

                $(".footer-content-inner").hide().removeClass("active");
                $(".footer-content-inner." + dataLink).show().addClass("active");

                var mho = $("#masthead").css("top");

                Site.footerH = Site.windowHeight - $("#masthead").height() - parseInt(mho) - $(".footer-absolute").height();

                if ($('#footer-content').height() != 0) {
                    //close
                    if (Site.curFooterDataLink == dataLink) {
                        $('#footer-content').stop().animate(
                            {'height': 0},
                            {
                                duration: 300
                            }
                        );
                        $("#footer-content").removeClass("active");
                    } else {
                        //TODO: fade from one content to another
                    }

                } else {
                    //open
                    $('#footer-content').stop().animate(
                        {'height': Site.footerH},
                        {
                            duration: 200,
                            progress: function () {
                                $('html, body').stop().animate({
                                    'scrollTop': $(document).height()
                                }, 0);
                            }
                        }
                    );
                }

                Site.curFooterDataLink = dataLink;
            };

            $('#footer-nav a.footer-trigger').click(function () {
                Site.toggleFooterContent($(this).attr("data-link"));
            });

            Site.setHomeChallenges = function () {
                window.challengeSlider = new Swipe(document.getElementById('challenges-slider'), {
                    speed: 1500,
                    auto: 10000,
                    continuous: true,
                    disableScroll: true,
                    stopPropagation: false,
                    callback: function (index, elem) {
                    },
                    transitionEnd: function (index, elem) {
                    }
                });

                $('.challenges-pagination .prev').on("click", function () {
                    window.challengeSlider.prev();
                });
                $('.challenges-pagination .next').on("click", function () {
                    window.challengeSlider.next();
                });
            };
            Site.fixFooterPos = function () {
                $('.footer-absolute').css("padding-left", Math.floor($(".footer-left").innerWidth()));
                $('.footer-absolute').css("padding-right", Math.floor($(".footer-right").innerWidth()));
            };
            Site.setSocialBoxes = function () {

                //SOCIAL
                var colsPerRow = [1, 2, 1];
                //current row, col
                var row = 0;
                var col = 0;
                var x;
                var y;
                var w;
                var h;
                var xoff = 0;
                $('.social-box').each(function (i, item) {
                        $(item).width($(item).find('a').width());
                        $(item).height($(item).find('a').height());
                        if (i == 0) {
                            //h/w with padding
                            w = $(item).innerWidth();
                            h = $(item).innerHeight();

                            xoff = Site.contentWidth / 2 - w / 2;
                        }

                        if (colsPerRow.length > row) {
                            y = row * h / 2;
                            x = xoff + (col * w) - ((colsPerRow[row] - 1) * w) / 2;
                            $(item).css('top', y);
                            $(item).css('left', x);
                            $(item).css('right', 'auto');

                            col++;
                            if (col == colsPerRow[row]) {
                                row++;
                                col = 0;
                            }
                        }
                    }
                );
                $('#social-boxes').height((row + 1) * h / 2);


            };
            Site.isMobile = function () {
                return Site.windowWidth <= 759;
            };

            Site.isDesktop = function () {
                return Site.windowWidth >= 1140;
            };

            Site.setNavigation = function () {
                var ww = Site.w.width();

                if(ww >= Site.navigationBreakpoint ) {
                    $("body").attr("data-nav", "full");
                    Site.fullNavigationActive = true;
                }
                else {
                    $("body").attr("data-nav", "compact");
                    Site.fullNavigationActive = false;
                }
            };

            Site.setHomeQualifiers = function () {
                if (Site.isMobile()) {
                    if (Site.resetResponsiveStyle) {
                        this.resetQualifiersInlineStyles();
                        Site.resetResponsiveStyle = false;
                    }
                }
                else {
                    var sw = Site.contentWidth;
                    var sh = -1;
                    var monthH = 0;
                    var lastY = 0;
                    var gridW = Math.floor(sw / 24);
                    var titleBoxSize = gridW*5;
                    var current_year = $("body").data("year");

                    if (!Site.pos) {
                        //positions based on months, starts with jan
                        Site.pos = [];
                        //entry: left, top, maxW, zIndex, boxAlignment["left" | "right"], boxOffset(% of boxSize)
                        //left, top: first element: % of siteWidth
                        //maxW, maxH: max % of siteWidth          -1 -> no scale defined
                        //pos[monthID] = [[left, top, maxW, zIndex, boxAlignment["left" | "right"], boxXOffset, [boxYOffset], [margBottom]], [...]];

                        /*--------------------------------------------------------------
                        2015
                        --------------------------------------------------------------*/

                        Site.pos[2015] = [];

                        //february
                        Site.pos[2015][0] = [
                            [0, 0, 9, 2, "right", -1, 0.3], // ocala
                            [8, .6, 12, 1, "right", -1, 0.4] // abu dhabi
                        ];
                        //april
                        Site.pos[2015][1] = [
                            [6, 0, 12, 1, "right", -2, 0.8] // coapexpan
                        ];
                        //may
                        Site.pos[2015][2] = [
                            [11, 0, 9, 2, "right", -1, 0.3], // lummen
                            [1, 0.5, 9, 2, "right", -2, 0.75], // linz
                            [10, 1.45, 10, 1, "left", -4, 0.5], // la baule
                            [2, 1.15, 9, 2, "right", -2, 0.7], // odense
                            [10, 0.9, 9, 1, "right", -1, .5], // rome
                            [1, 0.7, 8, 1, "right", -1, 0.64] // lisbon
                        ];
                        //june
                        Site.pos[2015][3] = [
                            [13, 0, 7, 1, "right", -1, 0.8], // sopot
                            [1, 0.4, 9, 2, "right", -1, 0.75], // st gallen
                            [7, 1.35, 12, 2, "left", -2, 0.5] // rotterdam
                        ];
                        // july
                        Site.pos[2015][4] = [
                            [16, 0.3, 8, 1, "left", -3, 0.2], // falsterbo
                            [3, -0.1, 8, 1, "left", -3, 0.5], // budapest
                            [13, 1.05, 10, 2, "left", -4, 0.15], // bratislava
                            [1, 0.7, 10, 3, "right", -1, 0.5] // hickstead
                        ];
                        // august
                        Site.pos[2015][5] = [
                            [4, 0, 9, 1, "left", -4, 0.5], // dublin
                            [15, 0.5, 9, 2, "left", -3, 0.74] // gijon
                        ];
                        // september
                        Site.pos[2015][6] = [
                            [11, 0, 11, 1, "left", -4, 0.5] // arezzo
                        ];

                        /*--------------------------------------------------------------
                        2016
                        --------------------------------------------------------------*/

                        Site.pos[2016] = [];

                        //february
                        Site.pos[2016][0] = [
                            [0, 0, 9, 2, "right", -1, 0.3], // abu dhabi
                            [8, .6, 12, 1, "right", -1, 0.4] // ocala
                        ];

                        //april
                        Site.pos[2016][1] = [
                            [0, 0, 9, 2, "right", -1, 0.3], // coapexpan
                            [8, .6, 12, 1, "right", -1, 0.4] // lummen
                        ];

                        //may
                        Site.pos[2016][2] = [
                            [11, 0, 9, 2, "right", -1, 0.3], // linz
                            [1, 0.5, 9, 2, "right", -2, 0.75], // celje
                            [10, 1.45, 10, 1, "left", -4, 0.5], // la baule
                            [2, 1.15, 9, 2, "right", -2, 0.7], // odense
                            [10, 1.05, 9, 1, "right", -1, .5], // lisbon
                            [1, 0.7, 8, 1, "right", -1, 0.64] // rome
                        ];

                        //june
                        Site.pos[2016][3] = [
                            [16, 0.3, 8, 2, "left", -3, 0.2], // langley
                            [3, -0.1, 8, 1, "left", -3, 0.5], // st gallen
                            [13, 1.3, 10, 1, "left", -4, 0.3], // sopot
                            [1, 1, 10, 3, "right", -1, 0.5] // rotterdam
                        ];

                        //july
                        Site.pos[2016][4] = [
                            [16, 0.3, 8, 2, "left", -3, 0.2], // falsterbo
                            [3, -0.1, 8, 1, "left", -3, 0.5], // budapest
                            [13, 1.25, 10, 1, "left", -4, 0.15], // dublin
                            [1, 0.8, 10, 2, "right", -1, 0.5] // hickstead
                        ];

                        //august
                        Site.pos[2016][5] = [
                            [11, 0, 11, 1, "left", -4, 0.5] // gijon
                        ];
                    }

                    $('.qualifiers-month').each(function (index1, month) {
                        numElements = $(month).find('li').length;
                        sh = -1;
                        lastY = 0;
                        monthH = 0;
                        var imgHeight;
                        var img;
                        //loop over month items
                        if (Site.pos[current_year][index1]) {
                            //loop over li items
                            $(month).find('li').each(function (index, eventItem) {

                                var vals = Site.pos[current_year][index1][index];

                                if (vals != null) {

                                    img = $(eventItem).find('img');

                                    titleBox = $(eventItem).find('.title-box');

                                    if ($(titleBox).find('.h2').text() == "Linz-Ebelsberg") {
                                        $(titleBox).find('.h2').text("Linz");
                                    }

                                    imgHeight = img.height();
                                    if (sh == -1) sh = imgHeight;

                                    var left = vals[0] * gridW;
                                    var top;
                                    var w = vals[2] * gridW;
                                    var z = vals[3];
                                    var boxAlign = vals[4];
                                    var boxOffsetX = vals[5];
                                    var boxOffsetY = vals[6];

                                    if (w != -1) {
                                        $(eventItem).find(".preload-image").css('width', w);
                                        img.css('max-width', w);
                                    }

                                    imgHeight = $(eventItem).find(".preload-image").outerHeight();
                                    if (sh == -1) sh = imgHeight;
                                    top = lastY + vals[1] * sh;

                                    $(eventItem).css('left', left);
                                    $(eventItem).css('top', top);
                                    $(eventItem).css('z-index', z);

                                    var oX = boxAlign == "right" ? -titleBox.width() - (gridW * boxOffsetX) : (gridW * boxOffsetX);
                                    titleBox.css(boxAlign, oX);
                                    titleBox.addClass("title-box-" + boxAlign);

                                    //yOffset of title box, optional
                                    if (vals[6]) {
                                        var oY = imgHeight * boxOffsetY;
                                        titleBox.css('top', oY);
                                        titleBox.css('margin-top', -titleBox.height() / 2);
                                    }

                                    lastY = top;
                                    sh = img.height();
                                    monthH = Math.max(monthH, lastY + $(eventItem).height());

                                    titleBox.css({
                                        'width': titleBoxSize,
                                        'height': titleBoxSize
                                    });

                                    titleBox.find(".title-box-inner").css({
                                        'height': titleBoxSize
                                    });
                                }

                            });

                            $(month).height(monthH);
                        }
                    });

                    Site.resetResponsiveStyle = true;
                }
            };
            Site.setSingleStream = function () {

                /* left offset first element, width first element,
                 margin right first element width second element */

                if (Site.isMobile()) {
                    $(".stream-item").each(function () {
                        $(this).attr("style", "");
                    });

                    $(".stream-row").each(function () {
                        $(this).attr("style", "");
                    });

                    $(".stream-row:nth-child(1)").attr("style", "");
                }
                else {
                    var streamLayouts = new Array();
                    streamLayouts[0] = [1, 9, 2, 12];
                    streamLayouts[1] = [1, 13, 1, 8];
                    streamLayouts[2] = [1, 8, 1, 13];
                    streamLayouts[3] = [3, 5, 2, 12];
                    streamLayouts[4] = [3, 10, 1, 7];

                    var layouts_max = streamLayouts.length;
                    var i = 0;

                    $(".row-double").each(function () {
                        var $r = $(this);
                        var $c1 = $r.find('.stream-item:nth-child(1)');
                        var $c2 = $r.find('.stream-item:nth-child(2)');
                        var rd = Math.floor(Math.random() * layouts_max);
                        var rd = i;
                        if (rd > layouts_max - 1) {
                            i = 0;
                            rd = 0;
                        }

                        $c1.css({
                            "width": streamLayouts[rd][1] * (100 / 24) + "%",
                            "margin-left": streamLayouts[rd][0] * (100 / 24) + "%",
                            "margin-right": streamLayouts[rd][2] * (100 / 24) + "%"
                        });
                        $c2.css({
                            "width": streamLayouts[rd][3] * (100 / 24) + "%"
                        });

                        $r.attr("data-layout", rd);

                        i = i + 1;
                    });

                    $(".stream-row").each(function () {
                        $(this).css({
                            "margin-bottom": $(this).width() / 24
                        });
                    });

                    var $srf = $(".stream-row:nth-child(1)");

                    $srf.css({
                        "padding-top": $srf.width() / 24
                    });
                }
            };

            Site.initStreamSharing = function () {
                var shareText = Site.getSharingText();
                var curPage = window.location.href;

                $(".diamond-facebook").click(function (e) {
                    e.preventDefault();
                    var shareImage = $(this).parent().parent().find("img").attr("src");
                    fbShare(curPage, shareText, ' ', shareImage, 520, 350);
                });

                $(".diamond-twitter").click(function (e) {
                    e.preventDefault();
                    twitterShare(curPage, 'Twitter Share', shareText, '', 520, 350);
                });

                $(".diamond-pinterest").click(function (e) {
                    e.preventDefault();
                    var shareImage = $(this).parent().parent().find("img").attr("src");
                    pinterestShare(curPage, shareText, 'Furusiyya FEI Nations Cup #SupportYourNation', shareImage, 800, 600);
                });
            };

            Site.setStream = function () {
                //GALLERY
                var colsPerRow = [2, 2];
                var row = 0;
                var col = 0;
                var imgX;
                var w;
                var rowHeight;
                var fullHeight = 0;
                var firstRowHeight = 0;

                var sw = Site.contentWidth;
                var gridW = sw / 24;

                var pos = [];

                if (Site.page == "home") {
                    //row 1
                    pos[0] = [
                        7, 10
                    ];
                    //row 2
                    pos[1] = [
                        10, 7
                    ];

                }
                else if (Site.page == "qualifier" || Site.page == "final" ) {
                    //row 1
                    pos[0] = [
                        10, 7
                    ];
                    //row 2
                    pos[1] = [
                        10, 7
                    ];
                }
                else if (Site.page == "team") {
                    //row 1
                    pos[0] = [
                        7, 10
                    ];
                    //row 2
                    pos[1] = [
                        7, 10
                    ];
                }

                //ROW LOOP
                $('.stream-gallery .stream-row').each(function (i, row) {
                    $(row).css('position', 'relative');

                    if (i == 1) {
                        $(row).css('margin-top', gridW);
                        fullHeight += gridW;
                    }

                    rowHeight = 0;
                    imgX = 0;
                    //IMG LOOP
                    $(row).find(' > div').each(function (j, item) {

                        if (Site.page == "stream-single") {
                            gX = pos[i % 2][j];
                        } else {
                            gX = pos[i][j];
                        }
                        $(item).css("position", "absolute");
                        $(item).css("width", gX * gridW);
                        $(item).css("left", imgX);

                        rowHeight = Math.max(rowHeight, $(item).height());

                        w = $(item).innerWidth();

                        //first row
                        if (i == 0) {
                            $(item).css('bottom', 0);
                            firstRowHeight = rowHeight;
                        } else {
                            //second row
                            $(item).css("top", 0);
                        }

                        imgX += (gX + 1) * gridW;
                    });

                    fullHeight += rowHeight;
                });

                $('.stream-gallery').height(fullHeight);
                $('.stream-gallery > div').css("padding-top", fullHeight / 2);

                var heightDiff = -( fullHeight / 2) + firstRowHeight;
                $('.stream-gallery').css("padding-top", heightDiff);

                if (Site.page == "home") {
                    $('.stream-gallery').css("margin-bottom", Site.calculateOffset() - heightDiff);
                    $('.stream-gallery').find(".diamond-wrapper").css("margin-top", gridW * 0.5 + (heightDiff) / 2);
                } else {
                    $('.stream-gallery').css("margin-bottom", 1.5 * gridW - heightDiff);
                    $('.stream-gallery').find(".diamond-wrapper").css("margin-top", gridW * 0.5 + heightDiff / 2);
                }

                $('.stream-gallery').css('width', gridW * 18);
                $('.stream-gallery').css("margin-right", "auto");
                $('.stream-gallery').css("margin-left", "auto");
            };

            Site.setVideoStream = function () {
                //GALLERY
                var colsPerRow = [2, 2];
                var row = 0;
                var col = 0;
                var imgX;
                var w;
                var rowHeight;
                var fullHeight = 0;
                var firstRowHeight = 0;

                var sw = Site.contentWidth;
                var gridW = sw / 24;

                var pos = [];

                if (Site.page == "home") {
                    //row 1
                    pos[0] = [
                        7, 10
                    ];
                    //row 2
                    pos[1] = [
                        10, 7
                    ];
                }

                /* diamond play too small on mobile */
                if(Site.isMobile()){
                    $('.page-template-home .videostream-gallery .row .diamond-wrapper').hide();
                }

                //ROW LOOP
                $('.videostream-gallery .stream-row').each(function (i, row) {
                    $(row).css('position', 'relative');

                    if (i == 1) {
                        $(row).css('margin-top', gridW);
                        fullHeight += gridW;
                    }

                    rowHeight = 0;
                    imgX = 0;
                    //IMG LOOP
                    $(row).find(' > div').each(function (j, item) {

                        if (Site.page == "stream-single") {
                            gX = pos[i % 2][j];
                        } else {
                            gX = pos[i][j];
                        }
                        $(item).css("position", "absolute");
                        $(item).css("width", gX * gridW);
                        $(item).css("left", imgX);

                        rowHeight = Math.max(rowHeight, $(item).height());

                        w = $(item).innerWidth();

                        //first row
                        if (i == 0) {
                            $(item).css('bottom', 0);
                            firstRowHeight = rowHeight;
                        } else {
                            //second row
                            $(item).css("top", 0);
                        }

                        imgX += (gX + 1) * gridW;
                    });

                    fullHeight += rowHeight;
                });

                $('.videostream-gallery').height(fullHeight);
                $('.videostream-gallery > div').css("padding-top", fullHeight / 2);

                var heightDiff = -( fullHeight / 2) + firstRowHeight;
                $('.videostream-gallery').css("padding-top", heightDiff);

                if (Site.page == "home") {
                    $('.videostream-gallery').css("margin-bottom", Site.calculateOffset() - heightDiff);
                    $('.videostream-gallery').find(".diamond-wrapper.wording").css("margin-top", gridW * 0.5 + (heightDiff) / 2);
                }

                $('.videostream-gallery').css('width', gridW * 18);
                $('.videostream-gallery').css("margin-right", "auto");
                $('.videostream-gallery').css("margin-left", "auto");
            }; // setVideoStream

            Site.setQualifiersHighlighter = function () {
                //var colsPerRowMobile = [3, 2, 3, 2, 3, 2, 3, 2];
                var colsPerRow = [];
                colsPerRow[0] = [1];                    //header
                colsPerRow[1] = [2];                    //header + 1 elements
                colsPerRow[2] = [1, 2];                 //header + 2 elements
                colsPerRow[3] = [1, 2, 1];              //header + 3 elements
                colsPerRow[4] = [1, 2, 3, 4, 5];           //header + 4+ elements


                var colsPerRowMobile = [];
                colsPerRowMobile[0] = [1];                    //header
                colsPerRowMobile[1] = [1, 1];                    //header + 1 elements
                colsPerRowMobile[2] = [1, 2];                 //header + 2 elements
                colsPerRowMobile[3] = [1, 2, 1];                 //header + 2 elements
                colsPerRowMobile[4] = [1, 2, 1, 2, 1, 2];                 //header + 2 elements

                var maxRowsMobile = 3;
                var maxRows = 5;

                //current row, col
                var row = 0;
                var col = 0;
                var x;
                var y;
                var w;
                var h;

                //debug: test layout for different num of elements
               /* var numFinalists = 4;
                while ($('#highlighted-finalists-list ul li').length > numFinalists + 1) {
                    $('#highlighted-finalists-list ul li:nth-of-type(' + $('#highlighted-finalists-list ul li').length + ')').remove();
                }

                while ($('#highlighted-finalists-list ul li').length < numFinalists + 1) {
                    console.log($('#highlighted-finalists-list ul li').length);
                    $('#highlighted-finalists-list ul li:nth-of-type(' + $('#highlighted-finalists-list ul li').length + ')').clone().appendTo('#highlighted-finalists-list ul');
                }
                */
                //end debug

                var numObjects = $('#highlighted-finalists-list ul li').length;

                var k;
                var colsPerRowResponsive;
                var maxRowsResponsive;
                if (Site.isMobile()) {
                    k = Math.min(numObjects - 1, colsPerRowMobile.length - 1);
                    colsPerRowResponsive = colsPerRowMobile[k];
                    maxRowsResponsive = maxRowsMobile;
                }
                else {
                    k = Math.min(numObjects - 1, colsPerRow.length - 1);
                    colsPerRowResponsive = colsPerRow[k];
                    maxRowsResponsive = maxRows;
                }

                $('#highlighted-finalists-list ul li').each(function (i, item) {
                        var cw = $("#highlighted-finalists-list").width();

                        w = cw / maxRowsResponsive;
                        h = cw / maxRowsResponsive;

                        $(item).outerWidth(Math.floor(w));
                        $(item).outerHeight(Math.floor(h));

                        iw = Math.floor($(item).width());
                        ih = Math.floor($(item).width());

                        $(item).find(".diamond.medium").width(iw).height(ih);


                        if (i < 2) {
                            xoff = (cw / 2) - (w / 2);
                        }

                        if (colsPerRowResponsive.length > row) {
                            y = (Site.isMobile() && (row == 1 && numObjects == 2)) ? row * h : row * h / 2;
                            x = xoff + (col * w) - ((colsPerRowResponsive[row] - 1) * w) / 2;
                            $(item).css('top', y);
                            $(item).css('left', x);
                            $(item).css('right', 'auto');

                            col++;
                            if (col == colsPerRowResponsive[row]) {
                                row++;
                                col = 0;
                            }
                        }
                    }
                );
                $('.finalist-list-ul').height((row + 1) * h / 2);
            };
            Site.setNationsList = function() {
                if( !$("#nations").length ) {
                    return;
                }
                else if( Site.isMobile() ) {
                    $("#nations .nations-competing-list").attr('style', '');
                    $("#nations .nations-competing-list li").each(function(){
                        $(this).attr('style', '');
                    });
                }
                else {
                    var $l = $("#nations .nations-competing-list");
                    var ds = $("#nations li:first-child").outerWidth();
                    var row = 0;
                    var col = 0;
                    var $nC = $l.find("li");

                    var colsperRow = [1, 2, 3, 2, 1]; // maximum of 9 teams

                    /* different layouts for different amounts of teams */

                    if($nC.length == 2) {
                        var colsperRow = [2];
                    }
                    else if($nC.length == 4) {
                        var colsperRow = [1, 2, 1];
                    }
                    else if($nC.length > 9) {
                        var colsperRow = [1, 2, 3, 2, 3, 2, 1]; // maximum of 14 teams
                    }

                    $nC.each(function(i, item){

                        $d = $(this);

                        /* set row and col */

                        if(colsperRow[row] <= col) {
                            row++;
                            col = 1;
                        }
                        else {
                            col++;
                        }

                        /* start calculating */

                        var rw = colsperRow[row]*ds;
                        var l = $l.outerWidth()/2 - rw/2 + (col-1)*ds;

                        $d.css({
                            'position': 'absolute',
                            'left': l + 'px',
                            'top': row*ds/2 + 'px'
                        });

                    });

                    if(row !== 0) {
                        var rs = (row+1)/2 + 0.5;
                        $l.css({ 'height': rs*ds });
                    }
                    else {
                        $l.css({ 'height': ds });
                    }
                }
            }
            Site.setHomeFinalists = function () {
                var colsPerRowMobile = [3, 2, 3, 2, 3, 2, 3, 2, 1];
                var colsPerRow = [1, 2, 3, 4, 3, 4, 3];

                var maxRowsMobile = 3;
                var maxRows = 5;

                //current row, col
                var row = 0;
                var col = 0;
                var x;
                var y;
                var w;
                var h;


                $('#home-finalists-list ul li').each(function (i, item) {

                        if (Site.windowWidth < 760) {
                            var colsPerRowResponsive = colsPerRowMobile;
                            var maxRowsResponsive = maxRowsMobile;
                        }
                        else {
                            var colsPerRowResponsive = colsPerRow;
                            var maxRowsResponsive = maxRows;
                        }

                        //h/w with padding

                        var cw = $("#home-finalists-list").width();

                        w = cw / maxRowsResponsive;
                        h = cw / maxRowsResponsive;

                        $(item).outerWidth(Math.floor(w));
                        $(item).outerHeight(Math.floor(h));

                        iw = Math.floor($(item).width());
                        ih = Math.floor($(item).width());

                        $(item).find(".diamond.medium").width(iw).height(ih);


                        if (i < 2) {
                            xoff = (cw / 2) - (w / 2);
                        }

                        if (i == 0 && Site.isMobile()) {
                            return;
                        }

                        if (colsPerRowResponsive.length > row) {
                            y = row * h / 2;
                            x = xoff + (col * w) - ((colsPerRowResponsive[row] - 1) * w) / 2;
                            $(item).css('top', y);
                            $(item).css('left', x);
                            $(item).css('right', 'auto');

                            col++;
                            if (col == colsPerRowResponsive[row]) {
                                row++;
                                col = 0;
                            }
                        }
                    }
                );
                $('.finalist-list-ul').height((row + 1) * h / 2);
            };
            Site.setHomeFinaleCounter = function () {
                //FINALE COUNTDOWN
                var secs = $('#finalsecs').text();
                $('#finalsecs').remove();

                //TODO: check if timer is correct ? days are okay
                millis = secs * 1000;

                var timerId =
                    countdown(
                        //month zero-based
                        //day one-based
                        new Date(2015, 8, 24, 0, 0, 0),
                        //new Date(millis),
                        function (ts) {
                            //document.getElementById('counter').innerHTML = ts.toHTML("strong");
                            $('#days').text(parseInt(ts.days) < 10 ? "0" + ts.days : ts.days);
                            $('#hours').text(parseInt(ts.hours) < 10 ? "0" + ts.hours : ts.hours);
                            $('#minutes').text(parseInt(ts.minutes) < 10 ? "0" + ts.minutes : ts.minutes);
                            $('#seconds').text(parseInt(ts.seconds) < 10 ? "0" + ts.seconds : ts.seconds);
                        },
                        countdown.DAYS | countdown.HOURS | countdown.MINUTES | countdown.SECONDS);
            };
            Site.setDividerHeights = function () {
                $(".divider").each(function () {
                    var $d = $(this);
                    var $di = $d.find(">:first-child");
                    $di.height($d.width());
                });
            };
            Site.setFirstDividerHeight = function () {
                var $d = $(".divider-one");
                var $di = $d.find(">:first-child");
                var $c = $("#series");

                var offset = Site.calculateOffset();

                var paddingNew = $d.width() / 2 + $c.height() + offset;
                var topNew = paddingNew - $d.width();

                $d.css({
                    "padding-top": paddingNew
                });

                $di.css({
                    "top": topNew
                });
            };
            Site.alignFinalDiamonds = function () {
                $("#final-counter .align-me").each(function () {
                    $(this).css({
                        "margin-top": -$(this).height() / 2
                    });
                });
            };
            Site.initLightbox = function() {
                if( !Site.isMobile() ) {
                    $('a[data-rel^=lightcase]').lightcase({
                        maxWidth: Site.windowWidth*0.9,
                        maxHeight: Site.windowHeight*0.85,
                        showTitle: true,
                        showCaption: false,
                        showSequenceInfo: false,
                        transition: 'fade',
                        overlayOpacity: 1,
                        onStart: {
                            bar: function() {
                                Site.lightboxStart();
                            }
                        },
                        onFinish: {
                            bar: function() {
                                Site.lightboxFinish();
                            }
                        },
                        onClose: {
                            bar: function() {
                                Site.lightboxClose();
                            }
                        }
                    });

                    $('a[data-rel^=lightcase]').each(function(){
                        var $l = $(this);
                        var ytid = $(this).attr('data-yt-id');
                        if (typeof ytid !== typeof undefined && ytid !== false) {
                            var ytembed = "http://www.youtube.com/embed/" + ytid + "?version=3";
                            $l.attr("href", ytembed);
                        }
                    });
                }
                else {
                    $('a[data-rel^=lightcase]').click(function(e) {
                        e.preventDefault();
                    });
                }
            };
            Site.lightboxStart = function() {
                if($(".stream-prev-next").length) {
                    $(".stream-prev-next").removeClass("hidden");
                } 

                $(".lightcase-contentInner img").on("mouseover", function(){
                    $(".stream-sharing-lightbox").removeClass("hidden");
                });
                $(".lightcase-contentInner img").on("mouseout", function(){
                    if (! $('.stream-sharing-lightbox').is(':hover') ) {
                        $(".stream-sharing-lightbox").addClass("hidden");
                    }
                });
            };
            Site.lightboxFinish = function() {
                if($(".stream-prev-next").length) {
                    /* set prev/next position */
                    var lightCaseWidth = $(".lightcase-contentInner").width();
                    $(".stream-prev-next .next").css({
                        'margin-left' : lightCaseWidth - $(".stream-prev-next .next").width() + "px"
                    });

                    /* set lightbox sharing position */
                    var lightCaseSharingOffset = $(".lightcase-contentInner").offset().top-$(".stream-sharing-lightbox").height()/2-Site.windowScrollTop;
                    $(".stream-sharing-lightbox").css({
                        'top' : lightCaseSharingOffset
                    });
                }
            };
            Site.lightboxClose = function() {
                if($(".stream-prev-next").length) {
                    $(".stream-prev-next").addClass("hidden");
                    $(".stream-sharing-lightbox").addClass("hidden");
                }
            };
            Site.initSkrollr = function() {
                Site.Skrollr = skrollr.init({
                    forceHeight: false
                });
            };
            Site.initPreloader = function() {
                $(".preloader-overlay").show(0);
            };
            Site.finishPreloader = function() {
                $w = $(window);
                var preloader_duration = 1400;
                var preloader_delay = 1000;

                $(".preloader-overlay__inner").fadeOut(1000);

                setTimeout(function() {
                
                    $(".preloader-overlay").animate({
                        "top": -$w.height()
                    }, preloader_duration*1, 'easeOutQuint');

                    $('#main').css({
                        "padding-top": $w.height()/6
                    }).animate({
                        "padding-top": 0
                    }, preloader_duration*0.8, 'easeOutQuint');

                }, preloader_delay);

                setTimeout(function() {
                    $(".preloader-overlay").css({
                        "left": -99999
                    }).addClass("loaded");
                }, preloader_delay+1000);

            };
            Site.setFooterNavigation = function() {
                var scrolledTrigger = 200; /* px */

                $(window).scroll(function(){
                    if( Site.isMobile() ) {
                        if( $("body").hasClass("scrolled") ) {
                            $("body").removeClass("scrolled");
                        }
                    }
                    else {
                        /* addClass scrolled */
                        if( Site.windowScrollTop >= scrolledTrigger && !Site.bodyEl.hasClass("scrolled") ) {
                            
                            if( !Site.bodyEl.hasClass("scrolled--bottom") ) {
                                Site.bodyEl.addClass("scrolled");
                            }
                            else if ( Site.bodyEl.hasClass("scrolled--bottom") && Site.bodyEl.hasClass("scrolled") ) {
                                Site.bodyEl.removeClass("scrolled");
                            }
                            
                            setTimeout(function () {
                                Site.fixFooterPos();
                            }, 400);
                        }
                        else if( Site.windowScrollTop < scrolledTrigger && Site.bodyEl.hasClass("scrolled") ) {
                            Site.bodyEl.removeClass("scrolled");
                        }

                        if (Site.page == "home") {
                            var range1_start = 0;
                            var range1_end = $(".divider-one").offset().top + $(".divider-one").outerHeight();
                            
                            var range2_start = $(".section.challenges").offset().top;
                            var range2_end = range2_start + $(".section.challenges").height();

                            var marker = Site.windowScrollTop + Site.windowHeight;
                            var fixedFooter = $(".footer-fixed");

                            if ( (range1_start < marker && marker < range1_end) || (range2_start < marker && marker < range2_end) ) {
                                if( !fixedFooter.hasClass("inverted") ) {
                                    fixedFooter.addClass("inverted");
                                }
                            }
                            else {
                                if( fixedFooter.hasClass("inverted") ) {
                                    fixedFooter.removeClass("inverted");
                                }
                            }
                        }

                        if( Site.windowScrollTop + Site.windowHeight >= Site.bodyEl.height() ) {
                            if( !Site.bodyEl.hasClass("scrolled--bottom") ) {
                                Site.bodyEl.addClass("scrolled--bottom");

                                if( Site.bodyEl.hasClass("scrolled") ) {
                                    Site.bodyEl.removeClass("scrolled");
                                    
                                    var FooterWidthInterval = window.setInterval(function () {
                                        Site.fixFooterPos();
                                    }, 16);

                                    setTimeout(function () {
                                        clearInterval(FooterWidthInterval);
                                    }, 400);
                                }
                            }
                        }
                        else {
                            if( Site.bodyEl.hasClass("scrolled--bottom") ) {
                                Site.bodyEl.removeClass("scrolled--bottom");
                            }
                        }
                    }
                });
            };
            Site.alignSections = function () {
                var mcw = $(".main-container").width();
                var offset = Site.calculateOffset();

                $(".section").each(function () {
                    var $s = $(this);
                    var $sc = $s.find(".section-content");

                    if ($sc.hasClass("pull")) {

                        var scTop = (-mcw / 2) + offset;

                        $sc.css({
                            top: scTop
                        });
                        var heightFactor = 2;

                        if ($sc.hasClass("only-top")) {
                            heightFactor = 1;
                        }

                        var parentHeight = $sc.outerHeight() + (heightFactor * scTop);
                        $s.css({
                            "height": parentHeight
                        });
                    }

                    if( !$s.hasClass("ready") ) {
                        $s.addClass("ready");
                    }

                    //set last divider diamond position
                    $innerDiamondHead = $sc.find("> .diamond-center-wrapper");
                    if ($innerDiamondHead.length > 0) {
                        $innerDiamondHead.css('margin-top', -$innerDiamondHead.height() / 2);
                    }
                });

                performanceTimer["sectionsAligned"] = new Date().getTime();
            };
            Site.initScrollSpy = function () {
                /* scrollspy */

                var current_class = "current-menu-item";
                var page_id = $("body").data("id");

                $(".section").each(function () {
                    var $s = $(this);
                    var sdh = $s.attr("id"); //data-target-hash
                    $s.on('scrollSpy:enter', function () {
                        /* section change */
                        $("ul.sub-menu li a[href^=#]").parent().removeClass(current_class);
                        if (typeof sdh !== typeof undefined && sdh !== false) {
                            $a = $("ul.sub-menu li a[href=#" + sdh + "]");
                            $a.parent().addClass(current_class);

                            var scroll_item_title = $a.text();

                            if( $a.text() !== "" && Site.fullNavigationActive == true ) {
                                $("li.page-item-" + page_id).find("> a").text(scroll_item_title);
                            }

                            if (Site.page == "home") {

                                //Site.setLocationAnchor(sdh);

                                $('.facebook-share').attr('curpageanchored', $('.facebook-share').attr('curPage') + '#' + sdh);
                                $('.twitter-share').attr('curpageanchored', $('.facebook-share').attr('curPage') + '#' + sdh);


                            }
                        }

                    });
                    $s.scrollSpy();
                });
            }
            Site.detectRetina = function () {
                if (Site.isRetina()) {
                    $("html").addClass("retina");
                }
            };
            Site.alignKeyFactDiamonds = function () {
                $k0 = $('#event-facts').find(".key-0");
                $k1 = $('#event-facts').find(".key-1");
                $k2 = $('#event-facts').find(".key-2");
                if (Site.isMobile()) {
                    $k0.css("margin-top", 0);
                    $k1.css("margin-top", 0);
                    $k2.css("margin-top", 0);
                }
                else {

                    $keyheight = $k1.height();

                    $k0.css("margin-top", -$k0.height() / 2);
                    $k1.css("margin-top", -$k1.height() / 2);
                    $k2.css("margin-top", -$k1.height() * 0.9 / 2);
                }

            };

            Site.initSocialFeed = function() {
                $(".social-feed-inner").feisocial({
                    /* general settings */
                    load_more: "#social-feed-load-more", /* button selector */
                    /* api and auth information */
                    instagram: {
                        query: "supportyournation",
                        auth: {
                            access_token: "304862890.1677ed0.cc3c92974f7b45eeaa402f46580b2ba5"
                        }
                    },
                    twitter: {
                        query: "supportyournation",
                        url: Site.theme_directory + "/misc/json/twitter.php"
                    },
                    facebook: {
                        query: "178629622184438:supportyournation",
                        auth: {
                            access_token: "1538702803095486|wzeAfmVkNCmXcxMj6b4sujVayUs"
                        }
                    }
                });
            };

            Site.initQualifierSingle = function () {
                /*
                $("#video").each(function (index, element) {
                    var vidLayer = $(element).find('.video-fs');
                    $('.video-poster').click(function () {
                        //TODO
                        //$('#youtube_id').get(0).playVideo();
                        //play video, show vid in fs lightbox
                        vidLayer.css("display", "block");
                    });
                });
                */

                Site.setStream();
                Site.setQualifiersHighlighter();
                Site.setDividerHeights();
                Site.setFirstDividerHeight();
                Site.alignSections();
                Site.fixFooterPos();
                Site.detectRetina();
                Site.alignKeyFactDiamonds();
                Site.initLightbox();
                Site.setNationsList();
            };
            Site.initTeamSingle = function () {
                Site.setStream();
                Site.setDividerHeights();
                Site.setFirstDividerHeight();
                Site.alignSections();
                Site.fixFooterPos();
                Site.detectRetina();
                Site.alignKeyFactDiamonds();
            };
            Site.initPageAbout = function () {
                Site.setSocialBoxes();
            };

            Site.initFinal = function() {
                Site.setQualifiersHighlighter();
                Site.setDividerHeights();
                Site.setFirstDividerHeight();
                Site.alignSections();
                Site.fixFooterPos();
                Site.detectRetina();
                Site.alignKeyFactDiamonds();
                Site.initLightbox();
                Site.setStream();
            };
            Site.updateFinal = function() {
                Site.setQualifiersHighlighter();
                Site.alignKeyFactDiamonds();
                Site.alignFinalDiamonds();
                Site.setStream();
            };

            Site.updateQualifiersSingle = function () {
                Site.setQualifiersHighlighter();
                Site.alignKeyFactDiamonds();
                Site.alignFinalDiamonds();
                Site.setStream();
                Site.setNationsList();
            };
            Site.updateTeamSingle = function () {
                Site.alignKeyFactDiamonds();
                Site.alignFinalDiamonds();
                Site.setStream();
            };

            Site.updateSingleStream = function () {
                Site.setSingleStream();
            };

            Site.initHome = function () {
                $('#qualifiers').css('display', 'block');
                Site.setHomeQualifiers();
                Site.setHomeFinalists();
                Site.setStream();
                Site.setVideoStream();
                Site.setSocialBoxes();
                //Site.setHomeChallenges();
                //Site.setHomeFinaleCounter();
                Site.setDividerHeights();
                Site.setFirstDividerHeight();
                
                performanceTimer["initHome"] = new Date().getTime();

                Site.alignSections();
                Site.fixFooterPos();
                Site.detectRetina();
                Site.alignFinalDiamonds();
                Site.initScrollSpy();
                Site.fixHomeAnchorPosition();

                /*Site.initSocialFeed();*/

                if (!Site.isMobile()) {
                    Site.setAnimationPath();
                    Site.setQualifiersAnimation();
                }

            };

            Site.updateAnimationPath = function () {
                if( !$('.qualifiers-list').length || $(".qualifiers-month").length < 5 ) {
                    return;
                }
                Site.aniSF = Math.max(1420 / $('#track-ani-svg').width(), 1);
                Site.aniPathHeight = $('.qualifiers-list').height();

                var qlOffset = $('.qualifiers-list').offset().top;
                Site.cY1 = $(".qualifiers-month").eq(2).offset().top - qlOffset - 100;
                Site.cY2 = $(".qualifiers-month").eq(3).offset().top - qlOffset - 135;
                Site.cY3 = $(".qualifiers-month").eq(5).offset().top - qlOffset - 100;

                $('#track-ani-svg').attr('height', ($('#track-ani-svg').height(), 10193 / Site.aniSF) + 'px');

                $(window).scroll();
            };
            Site.hideQualifiersForAnimation = function () {
                var $img = $('.home-event').find(".home-event-main-image");
                //var $box = $('.home-event').find(".title-box");

                $img.css('opacity', 0);

                $('.home-event').css('margin-top', '145px');
                $('.home-event').css('opacity', 0);
                $('.home-event').addClass('hidden');

            };
            Site.setQualifiersAnimation = function () {
                if( !$('.qualifiers-list').length ) {
                    return;
                }

                var viewportBottom = Site.windowScrollTop + Site.windowHeight;
                var qualifiersTop = $('.qualifiers-list').offset().top;
                if (viewportBottom < qualifiersTop + Site.windowHeight / 3) {
                    Site.hideQualifiersForAnimation();
                }

                //fadeIn qualifier if in viewport
                $(window).scroll(function () {
                    if (Site.isMobile()) {
                        return;
                    }
                    //update qualifiers visibility
                    var viewportTop = Site.windowScrollTop;
                    var viewportBottom = Site.windowScrollTop + Site.windowHeight;
                    var qualifiersTop = $('.qualifiers-list').offset().top;
                    if (viewportBottom < qualifiersTop + Site.windowHeight / 2) {
                        Site.hideQualifiersForAnimation();
                    }
                    $('.home-event.hidden').each(function () {
                        var itemTop = $(this).offset().top;
                        var $item = $(this);

                        if (itemTop > viewportTop && itemTop < viewportBottom - Site.windowHeight * .35) {

                            var $img = $item.find(".home-event-main-image");
                            var $box = $item.find(".title-box");

                            TweenLite.to($item, .85, {
                                css: { "margin-top": 0 },
                                ease: Strong.easeOut
                            });
                            TweenLite.to($item, .55, {
                                css: { "opacity": 1 }
                            });
                            TweenLite.to($img, .55, {
                                css: { "opacity": 1 },
                                delay: .1
                            });

                            $item.removeClass('hidden');
                        }
                    });
                });

            };

            Site.setAnimationPath = function () {

                function polarToCartesian(centerX, centerY, radius, angleInDegrees) {
                    var angleInRadians = (angleInDegrees - 90) * Math.PI / 180.0;

                    return {
                        x: centerX + (radius * Math.cos(angleInRadians)),
                        y: centerY + (radius * Math.sin(angleInRadians))
                    };
                }

                function describeArc(x, y, radius, startAngle, endAngle) {

                    var start = polarToCartesian(x, y, radius, endAngle);
                    var end = polarToCartesian(x, y, radius, startAngle);

                    var arcSweep = endAngle - startAngle <= 180 ? "0" : "1";

                    var d = [
                        "M", start.x, start.y,
                        "A", radius, radius, 0, arcSweep, 0, end.x, end.y
                    ].join(" ");

                    return d;
                }

                //var strokeColor = '#095E50';
                var strokeColor = '#12B298';
                var s = Snap("#track-ani-svg");

                var w = 1440;
                Site.aniPathHeight = $('.qualifiers-list').height();
                var midX = w / 2;

                var xPos = midX;
                var yPos = 0;

                //dashed midline
                var midLine = s.line(xPos, yPos, xPos, yPos).attr({
                    fill: "none",
                    stroke: "#0B7463", //lighter cause stronger
                    strokeWidth: 1,
                    "stroke-dasharray": "12,12"
                });

                var bezier1 = s.path("M257.123,374.709 C257.123,374.709 60.387,436.025 60.387,595.031 C60.387,843.762 282.795,880.898 686.454,1284.242 C889.597,1487.225 973.478,1643.271 973.478,1840.292 C973.478,2388 99.804,2736 237.798,3078").attr({
                    fill: "none",
                    stroke: strokeColor,
                    strokeWidth: 1
                });

                var bezier2 = s.path("M1103.02105,9050.24052 C908.661433,8112.80784 336.755118,7950.8334 294.924939,6885.04342 C243.443628,5573.35246 1154.76754,5576.64893 1131.68751,5172.07812 C1106.93751,4738.23438 701.16045,4342.55272 589.594791,4210.18525 C414.583406,4002.54238 407.107,3920.40822 407.107,3790.485 C407.107,3379.776 973.478,2953 973.478,2953").attr({
                    fill: "none",
                    stroke: strokeColor,
                    strokeWidth: 1
                });


                var bezier3 = s.path("M519.466,4095.418 C802.876,4154 1317.308,4266.875 1317.546,4546.875 C1317.743,4779.875 991.933,4978.284 689.479,5270.525 C482.959,5470.071 402.454,5606.283 402.454,5777.575").attr({
                    fill: "none",
                    stroke: strokeColor,
                    strokeWidth: 1
                });
                var bezier4 = s.path("M140.454,7756.50455 C777.800558,7840.63519 1022.14548,8111.4869 1022.38348,8391.4869 C1022.58048,8624.4869 696.770485,8822.8959 394.316485,9115.1369 C258.360013,9246.50224 177.016761,9350.41947 137.302381,9454.96684").attr({
                    fill: "none",
                    stroke: strokeColor,
                    strokeWidth: 1
                });


                var dashedBezier = s.path("M420,398 C640,606 973.478,908 973.478,1222 C973.478,1536 747.209,1688.259 606,1810 C413.454,1976 90,2139 90,2413 C90,2711 597.509,2824.629 892,2936").attr({
                    stroke: strokeColor,
                    fill: "none",
                    strokeWidth: 1,
                    "stroke-dasharray": "12,12"
                });

                var lines = s.group(bezier1, bezier2);
                var lines2 = s.group(bezier3, dashedBezier);
                var lines3 = s.group(bezier4);

                var bezierMask1 = s.rect(midX - w / 2, 0, w, 1).attr({
                    fill: strokeColor
                });

                var bezierMask2 = s.rect(midX - w / 2, 0, w, 1).attr({
                    fill: strokeColor
                });
                var bezierMask3 = s.rect(midX - w / 2, 0, w, 1).attr({
                    fill: strokeColor
                });

                lines.attr({
                    mask: bezierMask1
                });
                lines2.attr({
                    mask: bezierMask2
                });
                lines3.attr({
                    mask: bezierMask3
                });
                
                //draw circle

                var qual_count = $('.qualifiers-month').length;

                if(qual_count < 6) {
                    return false;
                }

                var qlTop = $('.qualifiers-list').offset().top;

                Site.cY1 = $(".qualifiers-month").eq(2).offset().top - qlTop - 100;
                Site.cY2 = $(".qualifiers-month").eq(3).offset().top - qlTop - 135;
                Site.cY3 = $(".qualifiers-month").eq(5).offset().top - qlTop - 100;
                var r = 250;
                var startAngle = 0;
                var endAngle = 0;
                var circle = s.path("M10,10").attr({
                    stroke: strokeColor,
                    fill: "none",
                    strokeWidth: 1,
                    "stroke-dasharray": "12,12",
                    id: 'circle-1'
                });
                var circle = s.path("M10,10").attr({
                    stroke: strokeColor,
                    fill: "none",
                    strokeWidth: 1,
                    "stroke-dasharray": "12,12",
                    id: 'circle-2'
                });
                var circle = s.path("M10,10").attr({
                    stroke: strokeColor,
                    fill: "none",
                    strokeWidth: 1,
                    "stroke-dasharray": "12,12",
                    id: 'circle-3'
                });

                var $dashOffset = $(".path").css("stroke-dashoffset");
                Site.aniSF = Math.max(1420 / $('#track-ani-svg').width(), 1);
                $(window).scroll(function () {
                    Site.aniPathHeight = $('.qualifiers-list').height() - 100;
                    var visibleHeight = Site.windowHeight;

                    var qualifiersScrollPosY = (Site.windowScrollTop - ($('#track-ani').offset().top - visibleHeight));
                    var $percentageComplete = (((qualifiersScrollPosY) / (Site.aniPathHeight - Site.windowHeight + visibleHeight)) * 100);
                    $percentageComplete > 1 ? 1 : $percentageComplete;
                    $percentageComplete < 0 ? 0 : $percentageComplete;
                    var perc = $percentageComplete / 100;

                    var line1Perc = perc * 1;
                    var line2Perc = perc * .7;
                    var line3Perc = perc * 1.5;
                    var line4Perc = perc * .3;

                    //debug
                    //line1Perc = line2Perc = line3Perc = 0;

                    var trackScrollTop = Site.windowScrollTop - ($('#track-ani').offset().top);

                    var lineHeight = trackScrollTop + (5 * visibleHeight / 8) + (3 * visibleHeight / 8) * line1Perc;
                    var bezierHeight = trackScrollTop + (2 * visibleHeight / 5) + (3 * visibleHeight / 5) * line2Perc;
                    var bezierHeight2 = trackScrollTop + (2 * visibleHeight / 5) + (3 * visibleHeight / 5) * line3Perc;
                    var bezierHeight3 = trackScrollTop + (2 * visibleHeight / 5) + (3 * visibleHeight / 5) * line4Perc;

                    midLine.attr({y2: lineHeight * Site.aniSF});
                    bezierMask1.attr({height: (bezierHeight < 0 ? 0 : bezierHeight) * Site.aniSF});
                    bezierMask2.attr({height: (bezierHeight2 < 0 ? 0 : bezierHeight2) * Site.aniSF});
                    bezierMask3.attr({height: (bezierHeight3 < 0 ? 0 : bezierHeight3) * Site.aniSF});

                    //draw first circle
                    var circleScrollTop = Site.windowScrollTop - ($(".qualifiers-month").eq(2).offset().top - 100);

                    endAngle = startAngle + 359 * (circleScrollTop + (visibleHeight)) / (visibleHeight * .5) * Site.aniSF;
                    endAngle = endAngle > 0 ? endAngle : 0;
                    endAngle = endAngle + startAngle > 359 ? endAngle = 359 - startAngle : endAngle;
                    d = describeArc(800, (Site.cY1 + r) * Site.aniSF, r, startAngle, endAngle);
                    $('#circle-1').attr("d", d);


                    //draw second circle
                    circleScrollTop = Site.windowScrollTop - ($(".qualifiers-month").eq(3).offset().top - 135);

                    endAngle = startAngle + 359 * (circleScrollTop + (visibleHeight)) / (visibleHeight * .5) * Site.aniSF;
                    endAngle = endAngle > 0 ? endAngle : 0;
                    endAngle = endAngle + startAngle > 359 ? endAngle = 359 - startAngle : endAngle;
                    d = describeArc(650, (Site.cY2 + r - 100) * Site.aniSF, r, startAngle, endAngle);
                    $('#circle-2').attr("d", d);


                    //draw second circle
                    circleScrollTop = Site.windowScrollTop - ($(".qualifiers-month").eq(5).offset().top - 100);

                    endAngle = startAngle + 359 * (circleScrollTop + (visibleHeight)) / (visibleHeight * .5) * Site.aniSF;
                    endAngle = endAngle > 0 ? endAngle : 0;
                    endAngle = endAngle + startAngle > 359 ? endAngle = 359 - startAngle : endAngle;
                    d = describeArc(900, (Site.cY3 + r) * Site.aniSF, r, startAngle, endAngle);
                    $('#circle-3').attr("d", d);
                });

                $(window).scroll();
            };
            Site.updateHome = function () {
                Site.setHomeQualifiers();
                Site.updateAnimationPath();
                Site.setHomeFinalists();
                Site.setStream();
                Site.setSocialBoxes();
                Site.setDividerHeights();
                Site.setFirstDividerHeight();
                Site.alignSections();
                if( Site.Skrollr !== false) {
                    Site.Skrollr.refresh();
                }
                Site.fixFooterPos();
                Site.alignFinalDiamonds();
            };

            Site.getSharingText = function( encoded ) {
                if(encoded == false) {
                    var sht = FEIsharingtext;
                }
                else {
                    var sht = encodeURIComponent(FEIsharingtext);
                }
                return sht;
            };

            Site.initFooterSocials = function () {
                $(".facebook-share").on('click', function (e) {
                    e.preventDefault();
                    
                    if( Site.page == "home" ) {
                        var curPage = $(this).attr('curpageanchored');
                    }
                    else {
                        var curPage = $(this).attr('curpage'); 
                    }

                    var shareText = Site.getSharingText();
                    fbShare(curPage, shareText, ' ', 'http://fei-feinationscup.s3-eu-west-1.amazonaws.com/wp-content/uploads/2015/04/qualifier-ocala-684x911.jpg', 520, 350);
                });


                $(".twitter-share").on('click', function (e) {
                    e.preventDefault();
                    
                    if( Site.page == "home" ) {
                        var curPage = $(this).attr('curpageanchored');
                    }
                    else {
                        var curPage = $(this).attr('curpage'); 
                    }

                    var twitterShareText = Site.getSharingText();

                    twitterShare(curPage, 'Twitter Share', twitterShareText, '', 520, 350);
                });


            };


            if (Site.page == "home") {
                Site.initHome();
                //todo clear this, check what to init and update for team page
            } else if (Site.page == "stream-single") {
                Site.setSingleStream();
                Site.initStreamSharing();
                Site.initLightbox();
            } else if (Site.page == "qualifier") {
                Site.initQualifierSingle();
            } else if (Site.page == "team") {
                Site.initTeamSingle();
            } else if (Site.page == "about") {
                Site.initPageAbout();
            } else if (Site.page == 'final') {
                Site.initFinal();
            }

            //FOOTER SOCIALS
            Site.initFooterSocials();

            //PRELOADER
            if( Site.enablePreloader == true ) {
                Site.initPreloader();
            }

            //SKROLLR ANIMATIONS
            if( Site.isDesktop() ){
                Site.initSkrollr();
            }

            Site.setNavigation();
            Site.setFooterNavigation();

            Site.w.trigger("resize");

            /*------------------------  custom FEI JS END ------------------------------------------  */
        },

        /**
         * Device targeting should be based on media queries in CSS,
         * we do not define this in scripts
         * Modified from http://davidwalsh.name/device-state-detection-css-media-queries-javascript
         */
        challengeContext: function () {
            var styles = window.getComputedStyle(this.challengeElement),
                index = parseInt(styles.getPropertyValue('z-index'), 10),
                states = {
                    1: 'mobile',
                    2: 'tablet'
                };

            this.context = states[index] || 'desktop';
        }
        ,
        performanceTiming: function() {
            console.log(performanceTimer);
            console.log(performanceTimer["sectionsAligned"]-performanceTimer["initHome"]);
        }
        ,
        /**
         * Throttle/debounce helper
         * Modified from http://remysharp.com/2010/07/21/throttling-function-calls/
         */
        debounce: function (fn, delay) {
            var timer = null;

            return function () {
                var context = this,
                    args = arguments;

                clearTimeout(timer);

                timer = setTimeout(function () {
                    fn.apply(context, args);
                }, delay);
            };
        }
        ,
        /**
         * Open/Close Mobile Main Menu
         */
        toggleMenu: function (that) {
            $(Site.nav).toggleClass('expanded');
        }
        ,
        hideMobileNav: function () {
            if ( $(Site.nav).hasClass('expanded') && Site.isMobile() ) {
                $(Site.nav).removeClass('expanded');
                Site.updateElements();
            }
        }
        ,
        calculateOffset: function () {
            //pretty much fluid, tweak the offset range! (min, max)
            var offsetRange = [180, 550];
            var scaleMax = 2400;
            /* should be the max with of the outer page container */
            var screenFactor = Site.windowWidth / scaleMax;

            //maximum offset, if window wider than max bg width, no scaling
            if (screenFactor >= 1) {
                var offset = offsetRange[1];
            }
            //if background is scaled
            else {
                //example: offsetRange = [100, 400];
                //example: 100 + 300*screenFactor (screenFactor = .5 if window width is 1200)
                //example: window width 1200 -> offset = 100 + 150 = 250
                var offsetCalc = offsetRange[0] + (offsetRange[1] - offsetRange[0]) * screenFactor;
                var offset = Math.floor(offsetCalc);
            }

            return offset;
        }
        ,
        isRetina: function () {
            return ((window.matchMedia && (window.matchMedia('only screen and (min-resolution: 124dpi), only screen and (min-resolution: 1.3dppx), only screen and (min-resolution: 48.8dpcm)').matches || window.matchMedia('only screen and (-webkit-min-device-pixel-ratio: 1.3), only screen and (-o-min-device-pixel-ratio: 2.6/2), only screen and (min--moz-device-pixel-ratio: 1.3), only screen and (min-device-pixel-ratio: 1.3)').matches)) || (window.devicePixelRatio && window.devicePixelRatio > 1.3));
        }
    }
    ;

    $(document).ready(function () {
        Site.init();
        Site.initFEI();
    });

    //TODO: check necessary function calls / position updates on load
    //      hide event items before image is loaded, load successively
    $(window).load(function () {
        //resize home qualifier elements
        if (Site.page == "home") {
            Site.updateHome();
        }
        else if (Site.page == "qualifier") {
            Site.updateQualifiersSingle();
        } else if (Site.page == "team") {
            Site.updateTeamSingle();
        }
        //  Site.alignSections();
        Site.fixFooterPos();
        //Site.updateElements();

        if( Site.enablePreloader == true ) {
            Site.finishPreloader();
        }
    });


})
(jQuery);

function fbShare(url, title, descr, image, winWidth, winHeight) {
    var winTop = (screen.height / 2) - (winHeight / 2);
    var winLeft = (screen.width / 2) - (winWidth / 2);

    var link = 'http://www.facebook.com/sharer/sharer.php?u=' + url;
    link = link.split("#").join('%2F%23');

    window.open(link, 'sharer', 'top=' + winTop + ',left=' + winLeft + ',toolbar=0,status=0,width=' + winWidth + ',height=' + winHeight);
}

function twitterShare(url, title, shareText, image, winWidth, winHeight) {
    var winTop = (screen.height / 2) - (winHeight / 2);
    var winLeft = (screen.width / 2) - (winWidth / 2);
    var link = 'http://www.twitter.com/share?url=' + url + '&amp;text=' + shareText;
    link = link.split("#").join('%2F%23');

    window.open(link, "_blank", "toolbar=no, scrollbars=no, resizable=no, top=" + winTop + ", left=" + winLeft + ", width=" + winWidth + ", height=" + winHeight);
}

function pinterestShare(url, title, descr, image, winWidth, winHeight) {
    var winTop = (screen.height / 2) - (winHeight / 2);
    var winLeft = (screen.width / 2) - (winWidth / 2);

    var link = 'https://www.pinterest.com/pin/create/button/?url=' + url + '&media=' + image + '&description=' + descr;
    link = link.split("#").join('%2F%23');

    window.open(link, 'sharer', 'top=' + winTop + ',left=' + winLeft + ',toolbar=0,status=0,width=' + winWidth + ',height=' + winHeight);
}
